const trait = this.actor.itemTags.trait.find(t => t.name === "Régénération");
const name = "Régénération Pourrie";

if (!trait) return;

const effect = trait.effects.find(e => e.name === "Régénération");
const scriptData = effect.system.scriptData;

scriptData[0].script = `
  let chatData = {whisper: ChatMessage.getWhisperRecipients("GM")};
  let message = "";

  let wounds = foundry.utils.duplicate(this.actor.status.wounds);
  let regenRoll = await new Roll("1d10").roll({allowInteractive : false});
  let regen = regenRoll.total;

  if (wounds.value >= wounds.max)
    return;

  if (wounds.value > 0) {
    wounds.value += Math.floor(regen / 2);
    if (wounds.value > wounds.max) {
      wounds.value = wounds.max;
    }
    message += \`<b>\${this.actor.name}</b> regagne \${regen} Blessures.\`;

    if (regen === 10) {
      message += "<br>De plus, il régénère une Blessure Critique.";
    }
  } else if (regen >= 8) {
    message += \`<b>\${this.actor.name}</b> a obtenu un \${regen} et regagne 1 Blessure.\`;
    wounds.value += 1;
    if (regen === 10) {
      message += "<br>De plus, il régénère une Blessure Critique.";
    }
  } else {
    message += \`<b>\${this.actor.name}</b> Résultat de régénération de \${regen} - Aucun effet.\`;
  }

  await this.actor.update({"system.status.wounds": wounds});
  this.script.message(message, {whisper: ChatMessage.getWhisperRecipients("GM")});
`

await effet.update({
  name,
  "system.scriptData": scriptData
});

await trait.update({ name });